"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _DataDictionaryTable = _interopRequireDefault(require("./table/DataDictionaryTable"));

var _DataModelStructure = _interopRequireDefault(require("./DataModelStructure"));

var _DataDictionaryGraph = _interopRequireDefault(require("./graph/DataDictionaryGraph"));

var _DictionarySearcher = _interopRequireDefault(require("./search/DictionarySearcher"));

var _DictionarySearchHistory = _interopRequireDefault(require("./search/DictionarySearchHistory"));

var _Model_View = _interopRequireDefault(require("../assets/Model_View.png"));

var _ReduxFacetFilter = _interopRequireDefault(require("./search/Filter/ReduxFacetFilter"));

require("./DataDictionary.css");

var _Header = _interopRequireDefault(require("./Header"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable max-len */

/* eslint-disable no-unused-vars */

/* eslint-disable no-console */
// import store from '../../../store/index';
// import { facetSearchData } from '../../../bento/dataDictionaryData';
var DataDictionary = function DataDictionary(_ref) {
  var classes = _ref.classes,
      onSetGraphView = _ref.onSetGraphView,
      isGraphView = _ref.isGraphView,
      pdfDownloadConfig = _ref.pdfDownloadConfig;

  var dictionarySearcherRef = _react.default.useRef();

  var setGraphView = function setGraphView(isGraphView) {
    onSetGraphView(isGraphView);
  };

  _react.default.useEffect(function () {
    setGraphView(true);
  }, []);

  var handleClickSearchHistoryItem = function handleClickSearchHistoryItem(keyword) {
    dictionarySearcherRef.current.launchSearchFromOutside(keyword);
  };

  var handleClearSearchResult = function handleClearSearchResult() {
    dictionarySearcherRef.current.launchClearSearchFromOutside();
  };

  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_Header.default, {
    pdfDownloadConfig: pdfDownloadConfig
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: classes.dataDictionary
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.sidebar
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.switch
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "".concat(!isGraphView ? classes.switchButton : classes.activeButton),
    onClick: function onClick() {
      setGraphView(true);
    },
    onKeyPress: function onKeyPress() {
      setGraphView(true);
    },
    role: "button",
    tabIndex: 0
  }, "Graph View"), /*#__PURE__*/_react.default.createElement("span", {
    className: "".concat(isGraphView ? classes.switchButton : classes.activeButton),
    onClick: function onClick() {
      setGraphView(false);
    },
    onKeyPress: function onKeyPress() {
      setGraphView(true);
    },
    role: "button",
    tabIndex: 0
  }, "Table View")), /*#__PURE__*/_react.default.createElement(_DictionarySearcher.default, {
    ref: dictionarySearcherRef
  }), /*#__PURE__*/_react.default.createElement(_DictionarySearchHistory.default, {
    onClickSearchHistoryItem: handleClickSearchHistoryItem
  }), /*#__PURE__*/_react.default.createElement(_ReduxFacetFilter.default, null)), /*#__PURE__*/_react.default.createElement("div", {
    className: isGraphView ? classes.mainGraphView : classes.mainTableView
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(classes.graph, " ").concat(!isGraphView ? classes.hidden : null)
  }, /*#__PURE__*/_react.default.createElement(_DataDictionaryGraph.default, {
    onClearSearchResult: handleClearSearchResult,
    pdfDownloadConfig: pdfDownloadConfig
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(classes.table, " ").concat(isGraphView ? classes.hidden : null)
  }, /*#__PURE__*/_react.default.createElement(_DataDictionaryTable.default, {
    pdfDownloadConfig: pdfDownloadConfig
  })))));
};

DataDictionary.propTypes = {
  onSetGraphView: _propTypes.default.func,
  isGraphView: _propTypes.default.bool
};
DataDictionary.defaultProps = {
  onSetGraphView: function onSetGraphView() {},
  isGraphView: false
};

var styles = function styles() {
  return {
    dataDictionary: {
      display: 'flex',
      height: 'calc(100vh)',
      overflowY: 'auto',
      backgroundImage: "url(".concat(_Model_View.default, ")")
    },
    sidebar: {
      width: '320px',
      minWidth: '320px',
      height: '100%',
      overflowY: 'auto',
      backgroundColor: 'var(--g3-color__white)',
      borderRight: '1px solid var(--g3-color__smoke)'
    },
    switch: {
      display: 'flex',
      border: '1px solid var(--g3-color__black)',
      borderRadius: '4px',
      cursor: 'pointer',
      fontSize: '18px',
      fontWeight: '600',
      letterSpacing: '.02rem',
      margin: '15px'
    },
    switchButton: {
      width: '50%',
      textAlign: 'center',
      padding: '10px'
    },
    activeButton: {
      width: '50%',
      textAlign: 'center',
      padding: '10px',
      backgroundColor: 'var(--g3-color__base-blue)',
      color: 'var(--g3-color__white)'
    },
    mainGraphView: {
      width: 'calc(100vw - 320px)',
      minWidth: '900px'
    },
    mainTableView: {
      width: 'calc(100vw - 320px)',
      minWidth: '900px',
      overflowY: 'scroll'
    },
    graph: {
      overflow: 'hidden',
      height: '100%',
      position: 'relative'
    },
    table: {
      padding: '20px'
    },
    hidden: {
      display: 'none'
    }
  };
};

var _default = (0, _core.withStyles)(styles)(DataDictionary);

exports.default = _default;