"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _Button = _interopRequireDefault(require("@gen3/ui-component/dist/components/Button"));

var _Dropdown = _interopRequireDefault(require("@gen3/ui-component/dist/components/Dropdown"));

var _helper = require("../NodeCategories/helper");

var _utils = require("../utils");

var _utils2 = require("../../utils");

var _DataModelStructure = _interopRequireDefault(require("./DataModelStructure.style"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DataModelStructure = /*#__PURE__*/function (_React$Component) {
  _inherits(DataModelStructure, _React$Component);

  var _super = _createSuper(DataModelStructure);

  function DataModelStructure() {
    var _this;

    _classCallCheck(this, DataModelStructure);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleClickGraphButton", function () {
      _this.props.onSetGraphView(true);

      _this.props.onResetGraphCanvas();
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickOverlayPropertyButton", function () {
      _this.props.onSetGraphView(true);

      _this.props.onSetOverlayPropertyTableHidden(!_this.props.overlayPropertyHidden);
    });

    _defineProperty(_assertThisInitialized(_this), "downloadTemplatesEnabled", function () {
      if (_this.props.relatedNodeIDs.length > _this.props.excludedNodesForTemplates) {
        return true;
      }

      var intersectionNodeIDs = (0, _utils2.intersection)(_this.props.relatedNodeIDs, _this.props.excludedNodesForTemplates);
      return intersectionNodeIDs.length !== _this.props.relatedNodeIDs.length;
    });

    _defineProperty(_assertThisInitialized(_this), "handleDownloadAllTemplates", function (format) {
      var nodesToDownload = {};

      _this.props.relatedNodeIDs.filter(function (nid) {
        return !_this.props.excludedNodesForTemplates.includes(nid);
      }).forEach(function (nid) {
        nodesToDownload[nid] = "".concat(nid, "-template.").concat(format);
      }, []);

      var allRoutes = _this.props.allRoutes.map(function (nodeIDsInRoute) {
        return nodeIDsInRoute.filter(function (nid) {
          return !_this.props.excludedNodesForTemplates.includes(nid);
        });
      });

      _this.props.downloadMultiTemplate(format, nodesToDownload, allRoutes, _this.props.clickingNodeName, _this.props.dictionaryVersion);
    });

    return _this;
  }

  _createClass(DataModelStructure, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          dataModelStructure = _this$props.dataModelStructure;
      if (!dataModelStructure) return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);
      return /*#__PURE__*/_react.default.createElement("div", {
        className: classes.dataModelStructure
      }, /*#__PURE__*/_react.default.createElement("h4", {
        className: classes.header
      }, "Data Model Structure"), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.containter
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.pathLine
      }), dataModelStructure.map(function (entry, i) {
        var nodeID = entry.nodeID,
            nodeIDsBefore = entry.nodeIDsBefore,
            linksBefore = entry.linksBefore,
            category = entry.category;
        var IconSVG = (0, _helper.getGraphCategoryIconSVG)(category);
        var lastNodeModifier = i === dataModelStructure.length - 1 ? classes.node_name__last : '';
        return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
          key: nodeID
        }, nodeIDsBefore.length > 0 && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
          className: classes.summaryBetween
        }, nodeIDsBefore.length, ' ', "nodes with", ' ', linksBefore.length, ' ', "links"), !_this2.props.isGraphView && /*#__PURE__*/_react.default.createElement(_Button.default, {
          onClick: _this2.handleClickGraphButton,
          label: "See it on graph",
          className: classes.graphButton,
          buttonType: "secondary"
        })), /*#__PURE__*/_react.default.createElement("div", {
          className: classes.node
        }, /*#__PURE__*/_react.default.createElement(IconSVG, {
          className: classes.icon
        }), /*#__PURE__*/_react.default.createElement("span", {
          className: "".concat(classes.nodeName, " ").concat(lastNodeModifier)
        }, nodeID)));
      })), this.props.isGraphView && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Button.default, {
        onClick: this.handleClickOverlayPropertyButton,
        label: this.props.overlayPropertyHidden ? 'Open properties' : 'Close properties',
        className: classes.tableButton,
        rightIcon: "list",
        buttonType: "primary"
      }), this.downloadTemplatesEnabled() && /*#__PURE__*/_react.default.createElement(_Dropdown.default, {
        className: classes.templateDownloadDropdown
      }, /*#__PURE__*/_react.default.createElement(_Dropdown.default.Button, null, "Download templates"), /*#__PURE__*/_react.default.createElement(_Dropdown.default.Menu, null, /*#__PURE__*/_react.default.createElement(_Dropdown.default.Item, {
        rightIcon: "download",
        onClick: function onClick() {
          return _this2.handleDownloadAllTemplates('tsv');
        }
      }, "TSV"), /*#__PURE__*/_react.default.createElement(_Dropdown.default.Item, {
        rightIcon: "download",
        onClick: function onClick() {
          return _this2.handleDownloadAllTemplates('json');
        }
      }, "JSON")))));
    }
  }]);

  return DataModelStructure;
}(_react.default.Component);

DataModelStructure.propTypes = {
  dataModelStructure: _propTypes.default.arrayOf(_propTypes.default.object),
  isGraphView: _propTypes.default.bool,
  onSetGraphView: _propTypes.default.func,
  onSetOverlayPropertyTableHidden: _propTypes.default.func,
  onResetGraphCanvas: _propTypes.default.func,
  overlayPropertyHidden: _propTypes.default.bool,
  downloadMultiTemplate: _propTypes.default.func,
  excludedNodesForTemplates: _propTypes.default.arrayOf(_propTypes.default.string),
  relatedNodeIDs: _propTypes.default.arrayOf(_propTypes.default.string),
  allRoutes: _propTypes.default.arrayOf(_propTypes.default.arrayOf(_propTypes.default.string)),
  clickingNodeName: _propTypes.default.string,
  dictionaryVersion: _propTypes.default.string
};
DataModelStructure.defaultProps = {
  dataModelStructure: null,
  isGraphView: true,
  onSetGraphView: function onSetGraphView() {},
  onSetOverlayPropertyTableHidden: function onSetOverlayPropertyTableHidden() {},
  onResetGraphCanvas: function onResetGraphCanvas() {},
  overlayPropertyHidden: true,
  downloadMultiTemplate: _utils.downloadMultiTemplate,
  excludedNodesForTemplates: ['program', 'project'],
  relatedNodeIDs: [],
  allRoutes: [],
  clickingNodeName: '',
  dictionaryVersion: 'Unknown'
};

var _default = (0, _core.withStyles)(_DataModelStructure.default)(DataModelStructure);

exports.default = _default;