"use strict";

var _testData = require("../../../GraphUtils/testData");

var _graphCalculatorHelper = require("./graphCalculatorHelper");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

describe('graphCalculatorHelper', function () {
  var _buildTestData = (0, _testData.buildTestData)(),
      dictionary = _buildTestData.dictionary,
      nodes = _buildTestData.nodes,
      edges = _buildTestData.edges;

  it('can calculate layout', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var layout;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _graphCalculatorHelper.calculateGraphLayout)(dictionary);

          case 2:
            layout = _context.sent;
            layout.nodes.forEach(function (n) {
              expect(nodes.find(function (testN) {
                return testN.id === n.id;
              })).toBeDefined();
            });
            layout.edges.forEach(function (e) {
              var found = edges.find(function (testE) {
                return testE.source === e.source && testE.target === e.target;
              });
              expect(found).toBeDefined();
            });

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('can get all types', function () {
    var types = (0, _graphCalculatorHelper.getAllTypes)(_testData.testGraph1.graphNodes);
    expect(types).toEqual(_testData.testGraph1.expectedNodeTypes);
  });
  it('can calculate related highlighting node IDs', function () {
    var relatedHighlightingNodeIDs = (0, _graphCalculatorHelper.calculateHighlightRelatedNodeIDs)(_testData.testGraph1.testClickNode, _testData.testGraph1.graphNodes);
    expect(relatedHighlightingNodeIDs).toEqual(_testData.testGraph1.expectedRelatedNodeIDs);
  });
  it('can calculate second highlighting node path', function () {
    var pathRelatedToSecondHighlightingNode = (0, _graphCalculatorHelper.calculatePathRelatedToSecondHighlightingNode)(_testData.testGraph1.testClickNode, _testData.testGraph1.testSecondClickNodeID, _testData.testGraph1.graphNodes);
    expect(pathRelatedToSecondHighlightingNode).toEqual(_testData.testGraph1.expectedSecondHighlightedPath);
  });
  it('can calculate data model structure', function () {
    var dataModelStructure = (0, _graphCalculatorHelper.calculateDataModelStructure)(_testData.testGraph1.startingNode, _testData.testGraph1.testSubgraph, _testData.testGraph1.testSubgraphEdges, _testData.testGraph1.graphNodes);
    expect(dataModelStructure).toEqual(_testData.testGraph1.expectedDataModelStructure);
  });
});