"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _GraphDrawer = _interopRequireDefault(require("../GraphDrawer/GraphDrawer"));

var _graphCalculatorHelper = require("../GraphCalculator/graphCalculatorHelper");

var _testData = require("../../../GraphUtils/testData");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

describe('GraphDrawer', function () {
  var hoverFunc = jest.fn();
  var cancelHoverFunc = jest.fn();
  var clickFunc = jest.fn();
  it('can render nodes and edges in graph', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var _buildTestData, dictionary, layout, graphDrawer;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _buildTestData = (0, _testData.buildTestData)(), dictionary = _buildTestData.dictionary;
            _context.next = 3;
            return (0, _graphCalculatorHelper.calculateGraphLayout)(dictionary);

          case 3:
            layout = _context.sent;
            graphDrawer = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_GraphDrawer.default, {
              nodes: layout.nodes,
              edges: layout.edges,
              layoutInitialized: true
            }));
            expect(graphDrawer.find(_GraphDrawer.default).length).toBe(1);
            expect(graphDrawer.find('.graph-node').length).toBe(layout.nodes.length);
            expect(graphDrawer.find('.graph-edge').length).toBe(layout.edges.length);

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('can hover and click nodes, and update svg element', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var _buildTestData2, dictionary, layout, graphDrawer, firstNodeElem;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _buildTestData2 = (0, _testData.buildTestData)(), dictionary = _buildTestData2.dictionary;
            _context2.next = 3;
            return (0, _graphCalculatorHelper.calculateGraphLayout)(dictionary);

          case 3:
            layout = _context2.sent;
            graphDrawer = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_GraphDrawer.default, {
              nodes: layout.nodes,
              edges: layout.edges,
              layoutInitialized: true,
              onHoverNode: hoverFunc,
              onCancelHoverNode: cancelHoverFunc,
              onClickNode: clickFunc
            }));
            firstNodeElem = graphDrawer.find('.graph-node').first();
            firstNodeElem.simulate('mouseover');
            expect(hoverFunc.mock.calls.length).toBe(1);
            firstNodeElem.simulate('mouseout');
            expect(cancelHoverFunc.mock.calls.length).toBe(1);
            firstNodeElem.simulate('click');
            expect(clickFunc.mock.calls.length).toBe(1);

          case 12:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
});