"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../../../utils");

var _helper = require("../../NodeCategories/helper");

require("./Legend.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Legend = /*#__PURE__*/function (_React$Component) {
  _inherits(Legend, _React$Component);

  var _super = _createSuper(Legend);

  function Legend(props) {
    var _this;

    _classCallCheck(this, Legend);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "toggleLegend", function () {
      _this.setState(function (state) {
        return {
          show: !state.show
        };
      });
    });

    _this.state = {
      show: true
    };
    return _this;
  }

  _createClass(Legend, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "data-dictionary-graph-legend ".concat(this.state.show ? '' : 'data-dictionary-graph-legend--toggled')
      }, this.state.show ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("i", {
        className: 'data-dictionary-graph-legend__close g3-icon g3-icon--cross',
        onClick: this.toggleLegend,
        onKeyPress: this.toggleLegend,
        role: 'button',
        tabIndex: 0
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "data-dictionary-graph-legend__item body"
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "data-dictionary-graph-legend__required-icon data-dictionary-graph-legend__required-icon g3-icon g3-icon--minus"
      }), /*#__PURE__*/_react.default.createElement("span", {
        className: "data-dictionary-graph-legend__text"
      }, "Relationships")), this.props.items.map(function (category) {
        var itemColor = (0, _helper.getCategoryColor)(category);
        var IconSvg = (0, _helper.getGraphCategoryIconSVG)(category);
        return /*#__PURE__*/_react.default.createElement("div", {
          key: category,
          className: 'data-dictionary-graph-legend__item body'
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: 'data-dictionary-graph-legend__circle-wrapper'
        }, IconSvg ? /*#__PURE__*/_react.default.createElement(IconSvg, null) : /*#__PURE__*/_react.default.createElement("span", {
          className: 'data-dictionary-graph-legend__circle',
          style: {
            backgroundColor: itemColor
          }
        })), /*#__PURE__*/_react.default.createElement("span", {
          className: 'data-dictionary-graph-legend__text'
        }, (0, _utils.capitalizeFirstLetter)(category)));
      })) : /*#__PURE__*/_react.default.createElement("span", {
        className: 'data-dictionary-graph-legend__info',
        onClick: this.toggleLegend,
        onKeyPress: this.toggleLegend,
        role: 'button',
        tabIndex: 0
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: 'data-dictionary-graph-legend__info-icon g3-icon g3-icon--question-mark'
      })));
    }
  }]);

  return Legend;
}(_react.default.Component);

Legend.propTypes = {
  items: _propTypes.default.arrayOf(_propTypes.default.string)
};
Legend.defaultProps = {
  items: []
};
var _default = Legend;
exports.default = _default;