"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _utils = require("../../utils");

var _helper = require("../../NodeCategories/helper");

var _DataDictionaryPropertyTable = _interopRequireDefault(require("../DataDictionaryPropertyTable"));

require("./DataDictionaryNode.css");

var _DataDictionaryNode2 = _interopRequireDefault(require("./DataDictionaryNode.style"));

var _NodeViewComponent = _interopRequireDefault(require("./components/NodeViewComponent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DataDictionaryNode = /*#__PURE__*/function (_React$Component) {
  _inherits(DataDictionaryNode, _React$Component);

  var _super = _createSuper(DataDictionaryNode);

  function DataDictionaryNode() {
    var _this;

    _classCallCheck(this, DataDictionaryNode);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "notHorizontal", true);

    _defineProperty(_assertThisInitialized(_this), "handleCloseNode", function () {
      _this.props.onExpandNode(null);
    });

    _defineProperty(_assertThisInitialized(_this), "handleDownloadTemplate", function (e, format) {
      e.stopPropagation(); // no toggling

      (0, _utils.downloadTemplate)(format, _this.props.node.id);
    });

    return _this;
  }

  _createClass(DataDictionaryNode, [{
    key: "handleClickNode",
    value: // supports landscape orientation
    function handleClickNode(nodeID) {
      if (!this.props.expanded) {
        this.props.onExpandNode(nodeID);
      } else {
        this.props.onExpandNode(null);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          node = _this$props.node,
          pdfDownloadConfig = _this$props.pdfDownloadConfig;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.node,
        style: {
          borderLeftColor: (0, _helper.getCategoryColor)(node.category)
        },
        onClick: function onClick() {
          return _this2.handleClickNode(node.id);
        },
        onKeyPress: function onKeyPress() {
          return _this2.handleClickNode(node.id);
        },
        role: "button",
        tabIndex: 0
      }, /*#__PURE__*/_react.default.createElement(_NodeViewComponent.default, {
        node: node,
        description: this.props.description,
        pdfDownloadConfig: pdfDownloadConfig
      })), this.props.expanded && /*#__PURE__*/_react.default.createElement("div", {
        className: classes.property
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: classes.propertyClose,
        onClick: this.handleCloseNode,
        onKeyPress: this.handleCloseNode,
        role: "button",
        tabIndex: 0
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "".concat(classes.propertyCloseIcon, " g3-icon g3-icon--sm g3-icon--cross")
      })), this.notHorizontal && /*#__PURE__*/_react.default.createElement("div", {
        className: classes.propertySummary
      }, /*#__PURE__*/_react.default.createElement("i", null, /*#__PURE__*/_react.default.createElement("span", null, node.title), /*#__PURE__*/_react.default.createElement("span", null, " has "), /*#__PURE__*/_react.default.createElement("span", null, Object.keys(node.properties).length), /*#__PURE__*/_react.default.createElement("span", null, " properties. "))), /*#__PURE__*/_react.default.createElement(_DataDictionaryPropertyTable.default, {
        title: node.title,
        properties: node.properties,
        requiredProperties: node.required,
        preferredProperties: node.preferred // horizontal // supports horizontal orientation

      })));
    }
  }]);

  return DataDictionaryNode;
}(_react.default.Component);

DataDictionaryNode.propTypes = {
  node: _propTypes.default.object.isRequired,
  description: _propTypes.default.string,
  expanded: _propTypes.default.bool,
  onExpandNode: _propTypes.default.func
};
DataDictionaryNode.defaultProps = {
  description: '',
  expanded: false,
  onExpandNode: function onExpandNode() {}
};

var _default = (0, _core.withStyles)(_DataDictionaryNode2.default)(DataDictionaryNode);

exports.default = _default;