"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _core = require("@material-ui/core");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _icons = require("@material-ui/icons");

var _fileSaver = require("file-saver");

var _utils = require("../../../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var DOWNLOADS = 'DOWNLOADS';
var filePerfix = 'ICDC_Controlled_Vocabulary-';
var FILE_TYPE_JSON = 'JSON';
var CONTENT_TYPE_JSON = 'application/json';
var CONTENT_TYPE_TSV = 'data:text/tab-separated-values';
var FILE_TYPE_TSV = 'TSV';
var fileTypes = [FILE_TYPE_JSON, FILE_TYPE_TSV];
var MuiMenu = (0, _core.withStyles)({
  paper: {
    border: '1px solid #0D71A3',
    width: '103px',
    borderRadius: '0px',
    '& .MuiList': {
      marginTop: '0px'
    }
  },
  list: {
    paddingBottom: '0px',
    paddingTop: '0px',
    marginTop: '0px'
  }
})(function (props) {
  return /*#__PURE__*/_react.default.createElement(_Menu.default, _extends({
    elevation: 0,
    getContentAnchorEl: null,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: 'center'
    },
    transformOrigin: {
      vertical: 'top',
      horizontal: 'center'
    }
  }, props));
});
var MuiMenuItem = (0, _core.withStyles)(function () {
  return {
    root: {
      '&:focus': {
        backgroundColor: 'none',
        '& .MuiListItemIcon-root': {
          backgroundColor: 'none'
        }
      }
    }
  };
})(_MenuItem.default);
var theme = {
  overrides: {
    MuiButton: {
      root: {
        minWidth: '10px'
      },
      startIcon: {
        marginRight: '0px'
      },
      label: {
        justifyContent: 'left'
      },
      outlined: {
        border: 'none'
      }
    }
  }
};

var DownloadFileTypeBtn = function DownloadFileTypeBtn(_ref) {
  var classes = _ref.classes,
      data = _ref.data,
      node = _ref.node,
      propertyKey = _ref.propertyKey;

  var _React$useState = _react.default.useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      anchorElement = _React$useState2[0],
      setAnchorElement = _React$useState2[1];

  var _useState = (0, _react.useState)('DOWNLOADS'),
      _useState2 = _slicedToArray(_useState, 2),
      label = _useState2[0],
      setLabel = _useState2[1];

  var clickHandler = function clickHandler(event) {
    setLabel('DOWNLOADS');
    setAnchorElement(event.currentTarget);
  };

  var closeHandler = function closeHandler() {
    setAnchorElement(null);
  };

  var setFileType = function setFileType(value) {
    setLabel(value);
    setAnchorElement(null);
  };

  var download = function download(data, fileType, contentType) {
    var exportData = new Blob([data], {
      type: contentType
    });
    var nodeTitle = (0, _utils.capitalizeFirstLetter)(node);
    var fileName = (0, _utils.createFileName)("".concat(nodeTitle, "-").concat(propertyKey), filePerfix);
    (0, _fileSaver.saveAs)(exportData, "".concat(fileName, ".").concat(fileType.toLowerCase()));
  };

  var downladFile = function downladFile() {
    if (label === FILE_TYPE_JSON) {
      var jsonData = JSON.stringify(data);
      download(jsonData, FILE_TYPE_JSON, CONTENT_TYPE_JSON);
    }

    if (label === FILE_TYPE_TSV) {
      var content = '';

      if (data && data.length) {
        data.forEach(function (item, index) {
          content += index == 0 ? item : '\n'.concat(item);
        });
      }

      download(content, FILE_TYPE_TSV, CONTENT_TYPE_TSV);
    }
  };

  var MenuItem = function MenuItem(type) {
    return /*#__PURE__*/_react.default.createElement(MuiMenuItem, {
      className: classes.menuItem,
      onClick: function onClick() {
        return setFileType(type);
      }
    }, type);
  };

  var options = fileTypes.map(function (item) {
    return MenuItem(item);
  });
  return /*#__PURE__*/_react.default.createElement(_core.MuiThemeProvider, {
    theme: (0, _core.createTheme)(theme)
  }, /*#__PURE__*/_react.default.createElement(_core.Box, {
    className: classes.menu
  }, /*#__PURE__*/_react.default.createElement(_Button.default, {
    disableRipple: true,
    disabled: DOWNLOADS === label,
    className: classes.downloadBtn,
    startIcon: /*#__PURE__*/_react.default.createElement(_icons.ArrowDownward, {
      className: classes.downloadIcon,
      id: "download_arrow"
    }),
    onClick: downladFile
  }), /*#__PURE__*/_react.default.createElement(_Button.default, {
    disableRipple: true,
    "aria-controls": "mui-menu",
    variant: "outlined",
    onClick: clickHandler,
    className: classes.displayBtn,
    startIcon: /*#__PURE__*/_react.default.createElement(_icons.ExpandMore, {
      className: classes.expandIcon
    })
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.dropDownText
  }, label)), /*#__PURE__*/_react.default.createElement(MuiMenu, {
    anchorEl: anchorElement,
    keepMounted: true,
    open: Boolean(anchorElement),
    onClose: closeHandler
  }, options)));
};

var styles = function styles() {
  return {
    menu: {
      border: '1px solid #0D71A3',
      boxSizing: 'border-box',
      backgroundColor: '#0D71A3',
      borderRadius: '5px',
      float: 'left'
    },
    displayBtn: {
      width: '102px',
      height: '2em',
      boxSizing: 'border-box',
      color: '#0d71a3',
      backgroundColor: '#F2F1F1',
      textTransform: 'none',
      padding: '7px',
      marginRight: '0',
      float: 'left',
      '&:hover': {
        cursor: 'pointer',
        backgroundColor: '#F2F1F1'
      }
    },
    dropDownText: {
      lineHeight: '1.05',
      fontSize: '10px',
      fontFamily: 'Open Sans',
      fontWeight: '600',
      color: '#0d71a3',
      textAlign: 'left',
      position: 'relative'
    },
    arrowDownward: {
      fontSize: '30px',
      color: '#DC762F'
    },
    menuItem: {
      fontSize: '10px',
      fontWeight: '700',
      paddingLeft: '22px',
      color: '#0d71a3',
      '&:last-child': {
        backgroundColor: '#CBE2EE',
        '&:hover': {
          backgroundColor: '#CBE2EE'
        }
      }
    },
    downloadBtn: {
      float: 'right',
      marginBottom: '-20px',
      height: '27px',
      width: '27px',
      backgroundColor: '#0D71A3',
      borderRadius: '0px',
      paddingLeft: '8px',
      '&:hover': {
        backgroundColor: '#0D71A3'
      }
    },
    downloadIcon: {
      color: '#fff',
      fontSize: '18px'
    }
  };
};

var _default = (0, _core.withStyles)(styles, {
  withTheme: true
})(DownloadFileTypeBtn);

exports.default = _default;