"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _core = require("@material-ui/core");

var _fileSaver = require("file-saver");

var _icons = require("@material-ui/icons");

var _Close = _interopRequireDefault(require("@material-ui/icons/Close"));

var _renderer = require("@react-pdf/renderer");

var _reactMarkdown = _interopRequireDefault(require("react-markdown"));

var _ReadMePdf = _interopRequireDefault(require("./ReadMePdf"));

var _ReadMe = _interopRequireDefault(require("./ReadMe.style"));

var _ReadMeTheme = _interopRequireDefault(require("./ReadMe.theme.config"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var ReadMeDialogComponent = function ReadMeDialogComponent(_ref) {
  var classes = _ref.classes,
      display = _ref.display,
      displayReadMeDialog = _ref.displayReadMeDialog,
      content = _ref.content,
      title = _ref.title;

  var downladFile = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var blob, fileName;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _renderer.pdf)( /*#__PURE__*/_react.default.createElement(_ReadMePdf.default, {
                title: title,
                content: content
              })).toBlob();

            case 2:
              blob = _context.sent;
              fileName = (0, _utils.createFileName)('read_me', 'ICDC_Data_Model-');
              (0, _fileSaver.saveAs)(blob, "".concat(fileName, ".pdf"));

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function downladFile() {
      return _ref2.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/_react.default.createElement(_ReadMeTheme.default, null, /*#__PURE__*/_react.default.createElement(_core.Dialog, {
    open: display,
    onClose: displayReadMeDialog,
    maxWidth: "md",
    className: classes.dialogBox,
    BackdropProps: {
      timeout: 500
    },
    BackdropComponent: _core.Backdrop
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.titleContent
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.title
  }, /*#__PURE__*/_react.default.createElement("span", null, title)), /*#__PURE__*/_react.default.createElement("div", {
    item: true,
    xs: 1,
    className: classes.closeBtn
  }, /*#__PURE__*/_react.default.createElement(_core.Button, {
    className: classes.downloadBtn,
    startIcon: /*#__PURE__*/_react.default.createElement(_icons.ArrowDownward, {
      className: classes.downloadIcon,
      id: "download_arrow_all"
    }),
    onClick: downladFile
  }), /*#__PURE__*/_react.default.createElement(_core.IconButton, {
    onClick: displayReadMeDialog
  }, /*#__PURE__*/_react.default.createElement(_Close.default, {
    fontSize: "small",
    className: classes.closeBtn
  })))), /*#__PURE__*/_react.default.createElement("div", {
    className: classes.content,
    id: "readMe_content"
  }, /*#__PURE__*/_react.default.createElement(_reactMarkdown.default, null, content))));
};

var _default = (0, _core.withStyles)(_ReadMe.default)(ReadMeDialogComponent);

exports.default = _default;