"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTheme = exports.CustomThemeProvider = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("@material-ui/core/styles");

var _themes = _interopRequireWildcard(require("./themes"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var lightTheme = (0, _styles.createMuiTheme)(_objectSpread(_objectSpread(_objectSpread({}, _themes.default.light), _themes.overrides), _themes.typography));
var darkTheme = (0, _styles.createMuiTheme)(_objectSpread(_objectSpread(_objectSpread({}, _themes.default.dark), _themes.overrides), _themes.typography));
var defaultContextData = {
  dark: false,
  toggleTheme: function toggleTheme() {}
};

var ThemeContext = /*#__PURE__*/_react.default.createContext(defaultContextData);

var useTheme = function useTheme() {
  return _react.default.useContext(ThemeContext);
};

exports.useTheme = useTheme;

var useEffectDarkMode = function useEffectDarkMode() {
  var _React$useState = _react.default.useState({
    dark: false,
    hasThemeMounted: false
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      themeState = _React$useState2[0],
      setThemeState = _React$useState2[1];

  _react.default.useEffect(function () {
    var lsDark = localStorage.getItem('dark') === 'true';
    setThemeState(_objectSpread(_objectSpread({}, themeState), {}, {
      dark: lsDark,
      hasThemeMounted: true
    }));
  }, []);

  return [themeState, setThemeState];
};

var CustomThemeProvider = function CustomThemeProvider(_ref) {
  var children = _ref.children;

  var _useEffectDarkMode = useEffectDarkMode(),
      _useEffectDarkMode2 = _slicedToArray(_useEffectDarkMode, 2),
      themeState = _useEffectDarkMode2[0],
      setThemeState = _useEffectDarkMode2[1];

  var toggleTheme = function toggleTheme() {
    var dark = !themeState.dark;
    localStorage.setItem('dark', JSON.stringify(dark));
    setThemeState(_objectSpread(_objectSpread({}, themeState), {}, {
      dark: dark
    }));
  };

  var computedTheme = themeState.dark ? darkTheme : lightTheme;
  return /*#__PURE__*/_react.default.createElement(_styles.MuiThemeProvider, {
    theme: computedTheme
  }, /*#__PURE__*/_react.default.createElement(ThemeContext.Provider, {
    value: {
      dark: themeState.dark,
      toggleTheme: toggleTheme
    }
  }, children));
};

exports.CustomThemeProvider = CustomThemeProvider;