"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _Button = _interopRequireDefault(require("@gen3/ui-component/dist/components/Button"));

var _highlightHelper = require("../../highlightHelper");

var _utils = require("../../utils");

var _utils2 = require("../../../utils");

var _helper = require("../../NodeCategories/helper");

var _DataDictionaryPropertyTable = _interopRequireDefault(require("../../table/DataDictionaryPropertyTable"));

var _OverlayPropertyTable = _interopRequireDefault(require("./OverlayPropertyTable.style"));

var _NodeViewComponent = _interopRequireDefault(require("../../table/DataDictionaryNode/components/NodeViewComponent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var OverlayPropertyTable = /*#__PURE__*/function (_React$Component) {
  _inherits(OverlayPropertyTable, _React$Component);

  var _super = _createSuper(OverlayPropertyTable);

  function OverlayPropertyTable() {
    var _this;

    _classCallCheck(this, OverlayPropertyTable);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "getTitle", function () {
      if (_this.props.isSearchMode) {
        var nodeTitleFragment = (0, _highlightHelper.getNodeTitleFragment)(_this.props.matchedResult.matches, _this.props.node.title, 'overlay-property-table__span');
        return nodeTitleFragment;
      }

      return _this.props.node.title;
    });

    _defineProperty(_assertThisInitialized(_this), "getDescription", function () {
      if (_this.props.isSearchMode) {
        var nodeDescriptionFragment = (0, _highlightHelper.getNodeDescriptionFragment)(_this.props.matchedResult.matches, _this.props.node.description, 'overlay-property-table__span');
        return nodeDescriptionFragment;
      }

      return _this.props.node.description;
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      _this.props.onCloseOverlayPropertyTable();
    });

    _defineProperty(_assertThisInitialized(_this), "handleOpenAllProperties", function () {
      _this.props.onOpenMatchedProperties();
    });

    _defineProperty(_assertThisInitialized(_this), "handleDisplayOnlyMatchedProperties", function () {
      _this.props.onCloseMatchedProperties();
    });

    return _this;
  }

  _createClass(OverlayPropertyTable, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          isSearchMode = _this$props.isSearchMode,
          node = _this$props.node,
          hidden = _this$props.hidden;
      if (!node || hidden) return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);
      var IconSVG = (0, _helper.getCategoryIconSVG)(node.category); // eslint-disable-next-line no-console

      var searchedNodeNotOpened = isSearchMode && !this.props.isSearchResultNodeOpened;
      var needHighlightSearchResult = isSearchMode; // const expanded = true;

      var categoryColor = (0, _helper.getCategoryColor)(node.category);
      return /*#__PURE__*/_react.default.createElement("div", {
        className: classes.table
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.background
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.fixedContainer
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.content
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.header
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.category,
        style: {
          borderLeftColor: categoryColor
        }
      }, /*#__PURE__*/_react.default.createElement(IconSVG, {
        className: "".concat(classes.categoryIcon, " ").concat(node.category)
      }), /*#__PURE__*/_react.default.createElement("h4", {
        style: {
          color: categoryColor
        },
        className: classes.categoryText
      }, (0, _utils2.capitalizeFirstLetter)(node.category)), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.buttonWrap
      }))), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.categoryDivider,
        style: {
          borderLeftColor: (0, _helper.getCategoryColor)(node.category)
        }
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.node,
        style: {
          borderLeftColor: (0, _helper.getCategoryColor)(node.category)
        }
      }, /*#__PURE__*/_react.default.createElement(_NodeViewComponent.default, {
        node: node,
        description: this.props.description,
        isSearchMode: isSearchMode,
        matchedResult: this.props.matchedResult,
        pdfDownloadConfig: this.props.pdfDownloadConfig
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.propertyTable
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.propertySummary
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: classes.close,
        onClick: this.handleClose,
        onKeyPress: this.handleClose,
        role: "button",
        tabIndex: 0
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "".concat(classes.closeIcon, " g3-icon g3-icon--cross g3-icon--sm")
      })), /*#__PURE__*/_react.default.createElement("i", null, /*#__PURE__*/_react.default.createElement("span", null, node.title), /*#__PURE__*/_react.default.createElement("span", null, " has "), /*#__PURE__*/_react.default.createElement("span", null, Object.keys(node.properties).length), /*#__PURE__*/_react.default.createElement("span", null, " properties. "))), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.property
      }, /*#__PURE__*/_react.default.createElement(_DataDictionaryPropertyTable.default, {
        title: node.title,
        properties: node.properties,
        requiredProperties: node.required,
        preferredProperties: node.preferred,
        hasBorder: false,
        onlyShowMatchedProperties: false,
        needHighlightSearchResult: needHighlightSearchResult // hideIsRequired={searchedNodeNotOpened}
        ,
        matchedResult: this.props.matchedResult,
        isSearchMode: isSearchMode
      }))))));
    }
  }]);

  return OverlayPropertyTable;
}(_react.default.Component);

OverlayPropertyTable.propTypes = {
  hidden: _propTypes.default.bool,
  node: _propTypes.default.object,
  onCloseOverlayPropertyTable: _propTypes.default.func,
  isSearchMode: _propTypes.default.bool,
  matchedResult: _utils.SearchResultItemShape,
  onOpenMatchedProperties: _propTypes.default.func,
  onCloseMatchedProperties: _propTypes.default.func,
  isSearchResultNodeOpened: _propTypes.default.bool
};
OverlayPropertyTable.defaultProps = {
  hidden: true,
  node: null,
  onCloseOverlayPropertyTable: function onCloseOverlayPropertyTable() {},
  isSearchMode: false,
  matchedResult: {},
  onOpenMatchedProperties: function onOpenMatchedProperties() {},
  onCloseMatchedProperties: function onCloseMatchedProperties() {},
  isSearchResultNodeOpened: false
};

var _default = (0, _core.withStyles)(_OverlayPropertyTable.default)(OverlayPropertyTable);

exports.default = _default;