"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _FacetFilters = _interopRequireDefault(require("./FacetFilters"));

var _action = require("../../action");

var _actions = require("../../store/actions/actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReduxFacetFilters = function ReduxFacetFilters(props) {
  return /*#__PURE__*/_react.default.createElement(_FacetFilters.default, props);
};

var mapStateToProps = function mapStateToProps(state) {
  return state;
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    onClearAllFilter: function onClearAllFilter() {
      return dispatch((0, _actions.clearAllFilters)());
    },
    onClickBlankSpace: function onClickBlankSpace() {
      return dispatch((0, _action.clickBlankSpace)());
    },
    hidePropertyTable: function hidePropertyTable() {
      return dispatch((0, _action.setOverlayPropertyTableHidden)(true));
    },
    onToggleCheckBox: function onToggleCheckBox(toggleCheckBoxItem) {
      return dispatch((0, _actions.toggleCheckBox)(toggleCheckBoxItem));
    },
    onSortSection: function onSortSection(groupName, sortBy) {
      return dispatch((0, _actions.sortSection)(groupName, sortBy));
    },
    onClearGroupFilter: function onClearGroupFilter(groupName) {
      return dispatch((0, _actions.clearGroupFilter)(groupName));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(ReduxFacetFilters);

exports.default = _default;